jls.loader.provide('jls.html.DomEvent');

jls.loader.require('jls.gui.Event');

jls.html.DomEvent = jls.lang.Class.create(jls.gui.Event, /** @lends jls.html.DomEvent.prototype */
{
    initialize : function(event, element) {
        this.type = event.type;
        this.target = event.target;
        this.timeStamp = event.timeStamp;
        this.element = element;
        this._event = event;
    },
    keyCode : function() {
        return ('which' in this._event) ? this._event.which : this._event.keyCode;
    }
});

if (window.attachEvent) { // IE specific event handling
	jls.html.DomEvent.addMethods({
	    stopPropagation : function() {
        	this._event.cancelBubble = true;
	    },
	    preventDefault : function() {
	    	this._event.returnValue = false;
	    }
	});
} else {
	jls.html.DomEvent.addMethods({
	    stopPropagation : function() {
        	this._event.stopPropagation();
	    },
	    preventDefault : function() {
        	this._event.preventDefault();
	    }
	});
}
