jls.loader.provide('jls.html.GuiUtilities');

//jls.loader.require('jls.html.BodyElement');

/**
 * @namespace Provides GUI classes for HTML.
 * @name jls.html
 */

jls.html.GuiUtilities = jls.lang.Class.create();

Object.extend(jls.html.GuiUtilities, /** @lends jls.html.GuiUtilities */
{
    getRoot : function() {
        return jls.html.BodyElement.getInstance();
    },
    invokeAndWait : function(fn) {
        return fn();
    },
    invokeLater : function(fn) {
    	setTimeout(fn, 10);
    }
});


jls.loader.provide('jls.html.BodyElement');

jls.loader.require('jls.html.HtmlElement');

jls.html.BodyElement = jls.lang.Class.create(jls.html.HtmlElement,
{
    getTitle : function() {
        return window.document.title;
    },
    setTitle : function(value) {
        window.document.title = this.getResourceLabel(value);
        return this;
    }
});

Object.extend(jls.html.BodyElement,
{
    _instance : null,
    getInstance : function() {
        if (jls.html.BodyElement._instance == null) {
            var body = document.getElementsByTagName('body')[0];
            jls.html.BodyElement._instance = new jls.html.BodyElement({attributes: {htmlElement: body}});
        }
        return jls.html.BodyElement._instance;
    }
});
